=== modified file 'CMakeLists.txt'
--- CMakeLists.txt	2017-01-24 20:55:19 +0000
+++ CMakeLists.txt	2018-12-04 21:17:43 +0000
@@ -38,7 +38,7 @@
     # On Windows we need to use cv2pdb (https://github.com/rainers/cv2pdb) to
     # provide debug information.
     # This can not be tested using cross-compile methods with MingW and Wine.
-    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c11 -mthreads -Wall -gdwarf-2 -pthread")
+    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c11 -mthreads -Wall -gdwarf-2")
 
     set (CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -std=c11 -mthreads -Wall -g -O0")
 

=== modified file 'libssts/LinkedList.c'
--- libssts/LinkedList.c	2016-08-07 21:08:54 +0000
+++ libssts/LinkedList.c	2018-12-04 21:17:43 +0000
@@ -21,8 +21,8 @@
 */
 
 #include <assert.h>
+#include <stdio.h>
 #include "LinkedList.h"
-#include "stdio.h"
 
 
 

=== modified file 'libssts/Thread.c'
--- libssts/Thread.c	2017-01-24 20:55:19 +0000
+++ libssts/Thread.c	2018-12-04 21:17:43 +0000
@@ -24,23 +24,23 @@
 s_thread_status_get_name (SThreadStatus status) {
   switch (status) {
     case (S_THREAD_STATUS_SUCCESS):
+      return SThreadStatusName[0];
+      break;
+    case (S_THREAD_STATUS_TIMEOUT):
       return SThreadStatusName[1];
       break;
-    case (S_THREAD_STATUS_TIMEOUT):
+    case (S_THREAD_STATUS_ERROR):
       return SThreadStatusName[2];
       break;
-    case (S_THREAD_STATUS_ERROR):
+    case (S_THREAD_STATUS_BUSY):
       return SThreadStatusName[3];
       break;
-    case (S_THREAD_STATUS_BUSY):
+    case (S_THREAD_STATUS_NO_MEM):
       return SThreadStatusName[4];
       break;
-    case (S_THREAD_STATUS_NO_MEM):
+    case (S_THREAD_STATUS_LAST):
       return SThreadStatusName[5];
       break;
-    case (S_THREAD_STATUS_LAST):
-      return SThreadStatusName[6];
-      break;
     default:
       return NULL;
   }
@@ -56,6 +56,25 @@
   _Atomic(sboolean) locked;
 };
 
+schar *
+s_mutex_flag_get_name (SMutexFlag flag) {
+  switch (flag) {
+    case (S_MUTEX_FLAG_PLAIN):
+      return SMutexFlagName[0];
+      break;
+    case (S_MUTEX_FLAG_TIMED):
+      return SMutexFlagName[1];
+      break;
+    case (S_MUTEX_FLAG_RECURSIVE):
+      return SMutexFlagName[2];
+      break;
+    case (S_MUTEX_FLAG_LAST):
+      return SMutexFlagName[3];
+      break;
+    default:
+      return NULL;
+  }
+}
 
 SMutex *
 s_mutex_new () {
@@ -140,7 +159,7 @@
 SThreadStatus
 s_thread_run (SThread * self, spointer user_data) {
   if (atomic_load(&(self->is_running)) == TRUE ) {
-    s_warn_print ("Trying to run a thread that allready is running."
+    s_err_print ("Trying to run a thread that allready is running."
                   "Returning.\n");
     return S_THREAD_STATUS_ERROR;
   }
@@ -151,13 +170,13 @@
 void
 s_thread_stop (SThread * self, sint res) {
   if (!thrd_equal (self->thread, thrd_current ())) {
-    s_warn_print ("Trying to exit thread that is not owned by current thread.\n"
+    s_err_print ("Trying to exit thread that is not owned by current thread.\n"
                   "Can only be called from running thread.\n");
     return;
   }
+  atomic_store (&(self->is_running), FALSE);
   thrd_exit (res);
-  
-  atomic_store (&(self->is_running), FALSE);
 }
 
 
+

=== modified file 'libssts/Thread.h'
--- libssts/Thread.h	2017-01-24 20:55:19 +0000
+++ libssts/Thread.h	2018-12-04 21:17:43 +0000
@@ -9,17 +9,17 @@
 
 #include "config.h"
 
-#if  !__STDC_NO_ATOMICS__
-#include <stdatomic.h>
-#else
+//#if  !__STDC_NO_ATOMICS__
+//#include <stdatomic.h>
+//#else
 #include "external/stdatomic.h"
-#endif
+//#endif
 
-#if !__STDC_NO_THREADS__
-#include <threads.h>
-#else
+//#if !__STDC_NO_THREADS__
+//#include <threads.h>
+//#else
 #include "external/tinycthread.h"
-#endif
+//#endif
 
 
 /**
@@ -43,12 +43,12 @@
  * offten used as return values for different fuctions.
  */
 typedef enum {
-  S_THREAD_STATUS_SUCCESS    = thrd_success,  /*< Succes*/
-  S_THREAD_STATUS_TIMEOUT    = thrd_timedout, /*< Timedout*/
-  S_THREAD_STATUS_ERROR      = thrd_error,    /*< Error */
-  S_THREAD_STATUS_BUSY       = thrd_busy,     /*< Busy */
-  S_THREAD_STATUS_NO_MEM     = thrd_nomem,    /*< No memory*/
-  S_THREAD_STATUS_LAST                        /*< Not used */
+  S_THREAD_STATUS_SUCCESS    = thrd_success,  /**< Succes*/
+  S_THREAD_STATUS_TIMEOUT    = thrd_timedout, /**< Timedout*/
+  S_THREAD_STATUS_ERROR      = thrd_error,    /**< Error */
+  S_THREAD_STATUS_BUSY       = thrd_busy,     /**< Busy */
+  S_THREAD_STATUS_NO_MEM     = thrd_nomem,    /**< No memory*/
+  S_THREAD_STATUS_LAST                        /**< Not used */
 } SThreadStatus;
 
 /**
@@ -83,8 +83,8 @@
  * These map 1:1 to the C11 flags.
  */
 typedef enum {
- S_MUTEX_FLAG_PLAIN = mtx_plain, /**< Plain mutex */
- S_MUTEX_FLAG_TIMED = mtx_timed, /**< Timed mutex */
+ S_MUTEX_FLAG_PLAIN     = mtx_plain,     /**< Plain mutex */
+ S_MUTEX_FLAG_TIMED     = mtx_timed,     /**< Timed mutex */
  S_MUTEX_FLAG_RECURSIVE = mtx_recursive, /**< Recursive mutex */
  S_MUTEX_FLAG_LAST
 } SMutexFlag;
@@ -163,7 +163,7 @@
 /**
  * Check if a mutex is locked.
  *
- * Note that this operation is non-atomic and may be wrong. 
+ * Note that this operation is non-atomic and may be wrong.
  */
 S_EXPORTED
 SThreadStatus
@@ -202,6 +202,10 @@
 
 /**
  * Run the thread.
+ *
+ * @note You must pass the self object as part of the user_data object, or have
+ *       the self object globally avalible. Otherwise you will not be able to
+ *       stop the thread using s_thread_stop.
  */
 S_EXPORTED
 SThreadStatus

=== added file 'libssts/meson.build'
--- libssts/meson.build	1970-01-01 00:00:00 +0000
+++ libssts/meson.build	2018-12-04 21:17:43 +0000
@@ -0,0 +1,138 @@
+config_h = configure_file (input : 'config.h.in',
+                output : 'config.h',
+                configuration : conf)
+
+libssts_header_files = []
+libssts_src_files = []
+
+subdir ('external')
+
+libssts_src_files += [
+    'Application.c',
+    'BaseN.c',
+    'baseobject.c',
+    'Box.c',
+    'Callback.c',
+    'defs.c',
+    'DynamicArray.c',
+    'Error.c',
+    'external/tinycthread.c',
+    'Func.c',
+    'GlobalNotify.c',
+    'hash.c',
+    'Interface.c',
+    'LinkedList.c',
+    'MainLoop.c',
+    'Map.c',
+    'Matrix.c',
+    'mm.c',
+    'mm_mark_and_sweep.c',
+    'primes.c',
+    'SimpleTypeSystem.c',
+    'Stream.c',
+    'Thread.c',
+    'types.c',
+    'utils.c',
+    'vec.c',
+]
+
+libssts_header_files += [
+    'Application.h',
+    'BaseN.h',
+    'baseobject.h',
+    'Box.h',
+    'Callback.h',
+    'defs.h',
+    'DynamicArray.h',
+    'Error.h',
+    './external/stdatomic.h',
+    './external/tinycthread.h',
+    'Func.h',
+    'Func.h',
+    'GlobalNotify.h',
+    'hash.h',
+    'Interface.h',
+    'LinkedList.h',
+    'MainLoop.h',
+    'Map.h',
+    'Matrix.h',
+    'mm.h',
+    'mm_mark_and_sweep.h',
+    'primes.h',
+    'SimpleTypeSystem.h',
+    'Stream.h',
+    'StreamPrivate.h',
+    'Thread.h',
+    'types.h',
+    'utils.h',
+]
+
+libssts_header_files += config_h
+install_headers (libssts_header_files, subdir : 'libssts', )
+
+libssts_files = libssts_src_files
+libssts_files += libssts_src_files
+
+
+library ('ssts',
+         libssts_src_files,
+         version: meson.project_version(),
+         soversion: meson.project_version()
+         )
+
+# libssts_files = files ('''
+#     Application.c
+#     Application.h
+#     baseobject.c
+#     baseobject.h
+#     Box.c
+#     Box.h
+#     BaseN.h
+#     BaseN.c
+#     Callback.c
+#     Callback.h
+#     defs.c
+#     defs.h
+#     DynamicArray.c
+#     DynamicArray.h
+#     Error.c
+#     Error.h
+#     Func.c
+#     Func.h
+#     GlobalNotify.c
+#     GlobalNotify.h
+#     hash.c
+#     hash.h
+#     Interface.c
+#     Interface.h
+#     LinkedList.c
+#     LinkedList.h
+#     Map.c
+#     Map.h
+#     mm.h
+#     mm.c
+#     mm_mark_and_sweep.h
+#     mm_mark_and_sweep.c
+#     Matrix.c
+#     Matrix.h
+#     MainLoop.c
+#     MainLoop.h
+#     primes.c
+#     primes.h
+#     Thread.c
+#     Thread.h
+#     types.c
+#     types.h
+#     external/tinycthread.c
+#     external/tinycthread.h
+#     SimpleTypeSystem.c
+#     SimpleTypeSystem.h
+#     Stream.c
+#     Stream.h
+#     StreamPrivate.h
+#     utils.c
+#     utils.h
+#     vec.c
+#     vec.h
+# '''.split())
+

=== added file 'meson.build'
--- meson.build	1970-01-01 00:00:00 +0000
+++ meson.build	2018-12-04 21:17:43 +0000
@@ -0,0 +1,43 @@
+project ('LibSSTS', 'c',
+         default_options : ['c_std=c11'],
+         version : '0.0.1',
+         license : 'MIT')
+
+conf = configuration_data ()
+
+version_array = meson.project_version ().split ('.')
+
+conf.set ('SSTS_V_MAJOR', version_array[0].to_int ())
+conf.set ('SSTS_V_MINOR', version_array[1].to_int ())
+conf.set ('SSTS_V_PATCH', version_array[2].to_int ())
+
+conf.set ('DEBUG', 'ON')
+conf.set ('S_USE_GC', 'ON')
+conf.set ('SSTS_BUILDING', 'ON')
+
+ssts_project_root = meson.source_root()
+
+
+cc = meson.get_compiler ('c')
+
+pthread_dep = cc.find_library ('threads',required : false)
+mthreads_dep = cc.find_library ('mthreads', required : false)
+# Need to figure out how to get if Boehm GC is included or not...
+boehm_dep = cc.find_library ('gc', required : false)
+# This will always exist, but we need to specify it anyways, Not needed on
+# Windows, it seems, as it is part of the standard library.
+mathlib_dep = cc.find_library ('m', required : false)
+
+if mthreads_dep.found ()
+  conf.set ('HAVE_MTHREAD', 'ON')
+  conf.set ('HAVE_PTHREAD', 'OFF')
+elif pthread_dep.found ()
+  conf.set ('HAVE_MTHREAD', 'OFF')
+  conf.set ('HAVE_PTHREAD', 'ON')
+else
+  conf.set ('HAVE_MTHREAD', 'OFF')
+  conf.set ('HAVE_PTHREAD', 'OFF')
+endif
+
+subdir ('libssts')
+

